#!------------------------------------------------------------------------------------------
#! NoActivate - Prevent an opening window from activating an application. 
#! (c) Copyright 2005 John Christ, All Rights Reserved
#!
#! Version 1.00  08/06/2005
#!
#!------------------------------------------------------------------------------------------
#TEMPLATE (NoActivate, 'NoActivate v1.00'),FAMILY('CW20','ABC')
#EXTENSION (NoActivateGlobal, 'NoActivate Global Extension'),APPLICATION,LAST
#BOXED(''),AT(,,195)
#BUTTON('About NoActivate Version 1.00'),AT(7,,189)
   #DISPLAY('NoActivate Version 1.00 for Clarion'),AT(26,,,)
   #DISPLAY('32 bit only'),AT(55,,,)
   #DISPLAY('')
   #DISPLAY('Copyright (C) 2005 by John Christ'),AT(29,,,)
   #DISPLAY('All Rights Reserved'),AT(50,,,)
   #DISPLAY('')
#ENDBUTTON
#ENDBOXED
#DISPLAY('Prevent an opening window from activating an application.')

#AT(%BeforeFileDeclarations)
! NoActivate
! Windows messages
NoActivate_WM_WINDOWPOSCHANGING EQUATE(0046h)
NoActivate_SWP_NOZORDER         EQUATE(0004h)
NoActivate_SWP_NOACTIVATE       EQUATE(0010h)
! NoActivate
#ENDAT

#AT(%GlobalMap)
! NoActivate
MODULE('NoActivate_win32.lib')
  NoActivate_CallWindowProc(LONG, UNSIGNED, UNSIGNED, SIGNED, LONG), LONG, PASCAL, RAW, DLL, PROC, NAME('CallWindowProcA')
END
! NoActivate
#ENDAT

#EXTENSION(NoActivate, 'NoActivate'),REQ(NoActivateGlobal),PROCEDURE
#AT(%DataSectionBeforeWindow)
! NoActivate
#IF(SUB(%cwversion,1,2)='55' OR SUB(%cwversion,1,2)='50')
NoActivate_lpOldWndProc LONG, STATIC
#ELSE
NoActivate_lpOldWndProc LONG, THREAD
#END
 MAP
NoActivate_NewWndProc PROCEDURE(UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL
 END
! NoActivate
#ENDAT

#AT(%AfterWindowOpening)
! NoActivate
NoActivate_lpOldWndProc = 0{PROP:WndProc}
0{PROP:WndProc} = ADDRESS(NoActivate_NewWndProc)
! NoActivate
#ENDAT

#AT(%LocalProcedures)
! NoActivate
NoActivate_NewWndProc PROCEDURE(UNSIGNED hWnd, UNSIGNED message, UNSIGNED wParam, LONG lParam)
NoActivate_WindowPosTYPE GROUP, PRE(NoActivate), TYPE
hWnd                     ULONG
hwndInsertAfter          ULONG
x                        LONG
y                        LONG
cx                       LONG
cy                       LONG
flags                    ULONG
  END
wp                      &NoActivate_WindowPosTYPE
  CODE
  CASE message
  OF NoActivate_WM_WINDOWPOSCHANGING
    wp &= (lParam)
    wp.flags = BOR(wp.Flags, BOR(NoActivate_SWP_NOACTIVATE, NoActivate_SWP_NOZORDER))
  END
  RETURN NoActivate_CallWindowProc(NoActivate_lpOldWndProc, hWnd, message, wParam, lParam)
! NoActivate
#ENDAT